#region Using

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;


using Wisej.Web;

#endregion

using System.Collections;

using System.Web;
using System.Security.Principal;
using System.IO;

using System.Reflection;

using Wisej.Core;

namespace WisejWebApplication
{
    interface IEditableBaseForm
    {
        bool IsDirty();
        bool CanPerformUpdate();
        bool Save();
    }
    /// <summary>
    /// Base class for all "ciselniky" form
    /// </summary>
    public partial class BaseDataForm : UserControl /*IGatewayControl*/, IEditableBaseForm

    {
#if TESTOVANI
        Wisej.Web.Extenders.UniqueIdExtender mobjUniqueIdExtender = new Wisej.Web.Extenders.UniqueIdExtender();
#endif
       
        protected bool raiseDispayedMessage = true;
        protected bool newRecordHidden = false;

        public enum DataFilteringMode { None, Text, Interval, Status, Custom };
        public enum EditorMode { Detail, Inline, Dialog, None }
        public enum RecordInfoMode { None, Total, IndexAndTotal }
        [Flags]
        public enum DataFlags { ReadOnly = 0, Insertable = 1, Deletable = 2, Editable = 4, Clonable = 8, Selection = 16 };

        DataFilteringMode dataFilteringMode;
        public DataFilteringMode DataFiltering
        {
            get { return dataFilteringMode; }
            set
            {
                dataFilteringMode = value;
                if (value != DataFilteringMode.None)
                    this.panelGrid.BorderStyle = BorderStyle.Solid;// new BorderWidth(0, 1, 0, 0);
            }
        }
        protected RecordInfoMode recordInfoMode;
        public RecordInfoMode CurrentRecordStatusMode
        {
            get { return recordInfoMode; }
            set { recordInfoMode = value; }
        }
        private CharacterCasing _filterCharCase;
        public CharacterCasing FilterCharCase
        {
            get { return _filterCharCase; }
            set { _filterCharCase = value; }
        }
        // 23.06.12 TQT added to support initial sort in data grid.
        public virtual string InitialSort
        {
            get { return String.Empty; }
        }
        ///+++++++++++++++++++++++++++++++
        /// <summary>
        /// Edit form
        /// </summary>
        protected object editDlg;
        private EditorMode editMode;
        [Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        [Obsolete("This attribute will be removed. Use EditMode member instead.")]
        public bool DetailFormModal
        {
            set
            {
                if (value)
                {
                    EditMode = EditorMode.Dialog;
                }
                else
                {
                    EditMode = EditorMode.Detail;
                }
            }
            get
            {
                return editMode == EditorMode.Dialog;
            }
        }
        public EditorMode EditMode
        {
            get { return editMode; }
            set
            {
                editMode = value;
                if (editMode == EditorMode.Inline)
                {
                    dataGridView.EditMode = DataGridViewEditMode.EditOnKeystrokeOrF2;
                    dataGridView.SelectionMode = DataGridViewSelectionMode.CellSelect;
                    dataGridView.ReadOnly = false;
                }
                else
                {
                    dataGridView.SelectionMode = DataGridViewSelectionMode.FullRowSelect;
                    dataGridView.ReadOnly = true;
                }
            }
        }
        private DataFlags dataMode;
        public DataFlags DataMode
        {
            get { return dataMode; }
            set
            {
                dataMode = value;
                
                    flowLayoutPanel1.Visible = true;
                    dataGridView.Dock = DockStyle.None;
            }
        }

        /// <summary>
        /// Set from other form, avoid old code set flowLayoutPanel1.Visible = false
        /// </summary>
        /// <param name="flag"></param>
        public void SetDataMode(DataFlags flag)
        {
            
        }
        [Browsable(false)]
        public bool DataClonable
        {
            get { return (dataMode & BaseDataForm.DataFlags.Clonable) != 0; }
            set { if (value) DataMode |= BaseDataForm.DataFlags.Clonable; else this.DataMode &= ~BaseDataForm.DataFlags.Clonable; }
        }
        [Browsable(false)]
        public bool DataInsertable
        {
            get { return (dataMode & DataFlags.Insertable) != 0; }
            set { if (value) DataMode |= DataFlags.Insertable; else DataMode &= ~DataFlags.Insertable; }
        }
        /// <summary>
        /// Flag to check if Add Button was clicked before
        /// </summary>
        protected bool add = false;

        protected Label totalRecords;

        /// <summary>
        /// Contructor for Base Data Form
        /// </summary>
        public BaseDataForm()
        {
            InitializeComponent();
            ExtraInitialize();

        }
        // "virtual" constructor that allows to call special initializer from descendant class
        // before base class fully initialized
        public BaseDataForm(params object[] args)
        {
            Initialize(args);
            InitializeComponent();
            ExtraInitialize();
        }
        // virtual initalizer
        protected virtual void Initialize(params object[] args)
        {
        }

        protected Timer gridTimer;
        private void ExtraInitialize()
        {
            dataMode = DataFlags.Insertable | DataFlags.Editable | DataFlags.Deletable;
            if (!DesignMode)
            {
                //this.BackColor = Color.Transparent;
                //this.dataGridView.BorderWidth = 1;
                //this.dataGridView.ColumnHeadersDefaultCellStyle.Font = new System.Drawing.Font("Tahoma", 8.25F);
                this.dataGridView.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft;
                this.dataGridView.ColumnHeadersDefaultCellStyle.WrapMode = DataGridViewTriState.False;

                this.dataGridView.DefaultCellStyle.Font = this.dataGridView.ColumnHeadersDefaultCellStyle.Font;
                this.dataGridView.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft;
                this.dataGridView.DefaultCellStyle.Padding = new Wisej.Web.Padding(0, 0, 0, 0);
                this.dataGridView.DefaultCellStyle.WrapMode = DataGridViewTriState.False;

                dataGridView.AutoGenerateColumns = false;
                dataGridView.RowHeadersWidth = 15;
                btnHide.TabStop = false;
                int async;
                
            }
            dataFilteringMode = DataFilteringMode.None;
        }

        protected virtual void SetToolTips()
        {
            
        }

        void gridTimer_Tick(object sender, EventArgs e)
        {
            gridTimer.Stop();
            CurrentItemChanged();
        }
        //Check again: in dialog mode does not need check dirty
        public virtual bool IsDirty()
        {
            
            return false;
        }

        public bool CanPerformUpdate()
        {
            
            return false;
        }

        public bool Save()
        {
            
            return false;
        }

        

        void editDlg_UpdateClick(object sender, EventArgs e)
        {
        }

        private void AddNewItem()
        {
            
        }

        /// <summary>
        /// Create new object Item 
        /// </summary>
        /// <returns></returns>
        protected virtual object CreateNewItem()
        {
           
            return null;
        }

        /// <summary>
        /// Save object to database and update Bindinglist
        /// </summary>
        /// <param name="obj"></param>
        /// <returns></returns>
        protected virtual bool UpdateData(object obj)
        {
            
            return false;
        }

        protected virtual bool CheckEditedItemMatchesFilter(object obj, int position, Type type)
        {
            MethodInfo mi = type.GetMethod("TestEditedMatchFilter", new Type[] { typeof(object), typeof(int) });
            if (mi != null)
            {
                return (bool)mi.Invoke(bindingSource.DataSource, new object[] { obj, position });
            }
            return true;
        }
        /// <summary>
        /// Set current item and index
        /// </summary>
        protected void SetCurrentItem()
        {
           
        }
        /// <summary>
        /// Delete object from database and update BindingList;
        /// </summary>
        /// <param name="obj"></param>
        /// <returns></returns>
        protected virtual bool RemoveItem(object obj)
        {
            
            return false;
        }
        
        protected object _currentItem;
        protected int _currentIndex;
        private void BindingSource_CurrentChanged(object sender, EventArgs e)
        {
        
        }

        
        protected virtual void CurrentItemChanged()
        {
            
        }

        private void SetEnableButtons4CurrentItem()
        {
            
        }

        

        protected virtual void RecordInfo()
        {
            if (recordInfoMode != RecordInfoMode.None)
            {
                if (totalRecords == null)
                {
                    totalRecords = new Label();
                }
                if (recordInfoMode == RecordInfoMode.IndexAndTotal)
                    totalRecords.Text = string.Format("Record {0}/{1}", bindingSource.Position + 1, bindingSource.List.Count);
                else if (recordInfoMode == RecordInfoMode.Total)
                    totalRecords.Text = "Records " + bindingSource.List.Count;
            }
        }
        //Trang refactor 8.1.2013
        /// <summary>
        /// Set enable button Edit,Remove,Dupplicate
        /// </summary>
        /// <param name="editable"></param>
        /// <param name="removeable"></param>
        /// <param name="duplicable"></param>
        /// <param name="Permisssion"></param>
        protected virtual void SetEnableEditButtons(bool editable, bool removeable, bool duplicable, int Permisssion)
        {
            SetBtnEdit(editable);
            btnRemove.Enabled = removeable;
            btnDuplicate.Enabled = duplicable; //22.11.2014 TQT duplicable && (Permisssion & (int)RIGHTS.INSERT) != 0;
        }

        protected virtual void SetBtnEdit(bool editable)
        {
        }

        /// <summary>
        /// Find index of current object in edit form.
        /// </summary>
        /// <param name="obj"></param>
        /// <returns></returns>
        internal virtual int FindIndex(object obj)
        {
            return 0;
        }

      

        protected virtual void AddItem()
        {
            
        }

        //------------------- Buttons ----------------------------------
        private void btnAdd_Click(object sender, EventArgs e)
        {
            AddItem();
        }

        public object GetCurrentItem()
        {
            return bindingSource.Current;
        }

        private void btnDuplicate_Click(object sender, EventArgs e)
        {
            DuplicateItem();
        }
        //Trang 24.10.2012 refactor
        protected virtual void DuplicateItem()
        {
            
        }

        protected virtual void EditItem()
        {
            
        }
        /// <summary>
        /// Test Write access to current Item
        /// </summary>
        /// <param name="o"></param>
        /// <returns></returns>
        protected bool EditableItem(object o)
        {
            bool editable = true;
            
            return editable;
        }

        private void btnEdit_Click(object sender, EventArgs e)
        {
            EditItem();
        }

        private void btnRemove_Click(object sender, EventArgs e)
        {
            RemoveClick();
        }

        protected virtual void RemoveClick()
        {
            
        }

        //01.10.2014 Trang close, implement interface IReference2OtherObj
        /// <summary>
        /// Check if object has reference to other objects
        /// if yes it can not be deleted.
        /// </summary>
        /// <param name="obj"></param>
        /// <returns></returns>
        //protected virtual bool HasReference2OtherObject(object obj)
        //{
        //    return false;
        //}

        protected virtual string CanNotDeleteMessage
        {
            get
            {
                return "aaaa";
            }
        }
        protected void RemoveItemFromDGV(DialogResult dialogResult)
        {
            
        }
        protected virtual void HandleException(Exception ex)
        {
            
        }


        protected bool showFilter = true;
        protected int FilterHeight = 0;
        private void splitContainer_DoubleClick(object sender, EventArgs e)
        {
            this.SuspendLayout();
            showFilter = !showFilter;
            if (!showFilter)
            {
                FilterHeight = splitContainer.SplitterDistance;
                splitContainer.SplitterDistance = btnHide.Height;
            }
            else
            {
                splitContainer.SplitterDistance = FilterHeight;
            }
            
            ShowFilter(showFilter);
            this.ResumeLayout(false);
        }

        //private void SplitterPanel_DoubleClick(object sender, EventArgs e)
        //{
        //    splitContainer_DoubleClick(sender, e);
        //}

        private void panelGrid_Resize(object sender, EventArgs e)
        {

        }

        /// <summary>
        /// Show/Hide filter panel on click on button Show/Hide 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnHide_Click(object sender, EventArgs e)
        {
            splitContainer_DoubleClick(sender, e);
        }
        /// <summary>
        ///  
        /// </summary>
        protected void OnFilter(dynamic pp)
        {
           
            DoFilter();
        }

        protected virtual void DoFilter()
        {
           
        }
        protected dynamic filter;
        private void ConfirmContinueFilter(DialogResult dialogResult)
        {
            
        }
        /// <summary>
        /// Set visible controls in filter panel
        /// </summary>
        /// <param name="show"></param>
        protected virtual void ShowFilter(bool show)
        {
            foreach (Control clt in splitContainer.Panel1.Controls)
            {
                if (clt != btnHide)
                    clt.Visible = show;
            }
        }
        
        /// <summary>
        /// Get data for BindingSource
        /// SubClass must override this method
        /// </summary>
        protected virtual IBindingList GetDataList()
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Get description of object
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        protected virtual string GetDesc(object item)
        {
            return item.ToString();
        }

        /// <summary>
        /// Show details form when double click on it's panel
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void panelDetails_DoubleClick(object sender, EventArgs e)
        {
            
        }


        private void BaseDataForm_Load(object sender, EventArgs e)
        {
            if (DesignMode) return;
            //SuspendLayout();
            
            SetToolTips();
            foreach (DataGridViewColumn col in dataGridView.Columns)
            {
                col.HeaderCell.Style.Padding = new Padding(2, 2, 2, 2);
            }
            //Trang 17.08.2012 Fix autogenerate FormatProvider
            this.dataGridView.RowTemplate.DefaultCellStyle.FormatProvider = System.Threading.Thread.CurrentThread.CurrentUICulture;
            btnRemove.Enabled = true;
           
                btnDuplicate.Visible = true;
                btnAdd.Visible = true;
                btnRemove.Visible = true ;
                
                btnAdd.Enabled =true;
              
                {
                    //Test when submit Finish
                    //cDPFinish.MinDate = 
                    cDPFinish.Value = DateTime.UtcNow.Date.AddDays(-1);                 
                }
            
            
            dataGridView.Focus();
           
            
            if (dataFilteringMode == DataFilteringMode.Custom)
            {
                SetEnterKeyDown(splitContainer.Panel1);
            }
            //if (filter != null)
            //{
            //    UserControl clt = (UserControl)filter;
               
            //    filter.CharCase = _filterCharCase;
            //    clt.Location = new Point(0, 2);
            //    splitContainer.Panel1.Controls.Add(clt);
            //    splitContainer.SplitterDistance = clt.Height + 5;
            //    btnHide.Visible = false;
            //    OnFilter(filter.Param);
            //}
            //panelGrid.Dock = DockStyle.Fill;
           
            if (this.ParentForm != null && this.ParentForm.Modal && EditMode != EditorMode.Detail)
            {
                
                Control parent = this.Parent;
                
                if (parent == null)
                {
                    btnOK.Visible = true;
                    btnCancel.Visible = true;
                }
            }
            //if (!btnOK.Visible) flowLayoutPanel1.Width = this.Width;
            //splitterDetails.IsSplitterFixed = true;
            splitterDetails.Height = 3;
            //Wisej.Web.Skins.FormSkin skin = Wisej.Web.Skins.SkinFactory.GetSkin(this.Form) as Wisej.Web.Skins.FormSkin;
            //splitterDetails.BorderColor = skin.DialogBackColor;
            //ResumeLayout(false);
        }
        
        public void HideOKCancel() 
        {
            btnOK.Visible = false;
            btnCancel.Visible = false;
        }


        private void SetEnterKeyDown(Control Container)
        {
            for (int i = 0; i < Container.Controls.Count; i++)
            {
                Control clt = Container.Controls[i];
                if (clt.Controls.Count > 0 && clt.Tag == null)
                {
                    SetEnterKeyDown(clt);
                    continue;
                }
                if ((clt is TextBox) && clt.Tag == null)
                {
                    (clt as TextBox).KeyDown += new KeyEventHandler(Filter_EnterKeyDown);
                }
            }
        }

        void Filter_EnterKeyDown(object objSender, KeyEventArgs objArgs)
        {
            if(objArgs.KeyCode == Keys.Enter)
            GetFilterParamAndDoFilter();
        }
        protected virtual void GetFilterParamAndDoFilter()
        {

        }

        protected virtual void ShowInDialog_Click(object sender, EventArgs e)
        {
            
        }

        public void HideDetail()
        {
            
        }
        //Trang 11.03.2013 Call from outside
        public virtual void btnExcel_Click(object sender, EventArgs e)
        {
           
        }

        
        private void dataGridView_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Enter && editDlg != null)
            {
               
            }
        }

        public static void SetDateColumnFormat(DataGridViewColumn column)
        {
           
        }

        public static void SetDateTimeColumnFormat(DataGridViewColumn column)
        {
            
        }

        private void dataGridView_RowDirtyStateNeeded(object sender, QuestionEventArgs e)
        {

        }

        private void FinishItem(DialogResult dialogResult)
        {
           
        }

        
        private void btnFinish_Click(object sender, EventArgs e)
        {
           
        }
        // 21.05.12 TQT added
        protected virtual void EnableGridControls(bool enabled)
        {
           
        }

        private void bindingSource_ListChanged(object sender, ListChangedEventArgs e)
        {
          
        }

        public virtual void btnHistory_Click(object sender, EventArgs e)
        {
            
        }

        protected virtual string[] GetFormatColumns()
        {
            return null;
        }

        //17.12.2013 Szabo
        protected virtual int[] GetHistoryFormColumnsWidth()
        {
            return null;
        }
        //8.1.2014 Szabo
        protected virtual Dictionary<int, string> GetColumnDateTimeFormats()
        {
            return null;
        }
        //27.1.2015 Szabo
        protected virtual Dictionary<int, string> GetColumnStyleFormat()
        {
            return null;
        }
        protected virtual Dictionary<int, ListSortDirection> GetSortColumn()
        {
            return null;
        }

        protected virtual string GetHistoryText(object curItem)
        {
            return "History data for record: " + GetDesc(curItem);
        }
        /// <summary>
        /// Default 3 : systmchng, sysuser, terminal
        /// </summary>
        /// <returns></returns>
        protected virtual int SetFrozenIndex()
        {
            return 3;
        }

        protected virtual DataTable GetHistoryData(object curItem)
        {
            return new DataTable();
        }
        

        ///Show form as modal dialog
        /// TQT added 18.12.2013
        /// 
        public DialogResult ShowModal(EventHandler OnFormClosed, MessageBoxButtons buttons = MessageBoxButtons.OKCancel)
        {
            Form _form = null;
           
            DialogResult result = _form.ShowDialog();
            if (buttons == MessageBoxButtons.OK) btnCancel.Visible = false;
            return result;
        }

        void _form_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (editDlg != null)
            {
            }
        }
        protected bool AskOnClosing = false;
        public DialogResult ShowDialog(EventHandler OnFormClosed,bool askOnClosing = false)
        {
            Form _form = null;
            
            _form.ResumeLayout();
            DialogResult result = _form.ShowDialog();
            //if (buttons == MessageBoxButtons.OK) btnCancel.Visible = false;
            return result;
        }

        void _form_FormClosing(object sender, FormClosingEventArgs e)
        {
           
        }

        private void GetConfirmClose(DialogResult dialogResult)
        {
            if (dialogResult == Wisej.Web.DialogResult.Yes)
            {
                Form frm = this.FindForm();
                frm.DialogResult = Wisej.Web.DialogResult.OK;
                //signal MainForm to save changes
                frm.Close();
            }
            else
            {
                AskOnClosing = true;
            }
        }
        

        // 06.01.2014 TQT added
        public virtual string GetFormArgs()
        {
            return null;
        }
        //23.01.14 Trang override for other purpose
        protected virtual void btnOK_Click(object sender, System.EventArgs e)
        {
            Form frm = this.FindForm();
            if (frm == null) return;
            frm.DialogResult = DialogResult.OK;
            frm.Close();
        }

        ///
        //public virtual bool WriteAccess
        //{
        //    get
        //    {
        //        IPrincipal User = HttpContext.Current.User;
        //        string role = GetRole4Task("write");
        //        //if (string.IsNullOrEmpty(role))
        //            //return LDAP.IsUrlWritable(Request.Path);
        //        //else
        //            return User.IsInRole(role);
        //    }
        //}

        //protected string GetRole4Task(string task)
        //{
        //    string key = this.GetType() + ":" + task;
        //    return AppSettings.GetString(key);
        //}
        protected new bool DesignMode => base.DesignMode || LicenseManager.UsageMode == LicenseUsageMode.Designtime;
    }
}
