using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;

using Wisej.Web;

namespace WisejWebApplication
{
    public partial class DockableControl : UserControl, IDockableControl
    {
        //29.1.12 Szabo - udalost na uzatvorenie DetailForm v casti parent Form
        public event EventHandler CloseDetail;
        private AnchorStyles dockAnchor;
        public AnchorStyles DockAnchor
        {
            get { return dockAnchor; }
            set { dockAnchor = value; }
        }
        private Panel _panel;
        /// <summary>
        /// Panel contains this control
        /// </summary>
        public Panel PanelContainer { set { _panel = value; } get { return _panel; } }

        private Panel _relativePanel;
        /// <summary>
        /// Relative panel, which needs to be resized
        /// </summary>
        public Panel RelativePanel { set { _relativePanel = value; } get { return _relativePanel; } }

        private Form _form;
        /// <summary>
        /// Form contains this control
        /// </summary>
        public Form FormContainer { set { _form = value; } get { return _form; } }

        

        public void ShowInDialog()
        {
            Form form = ParentForm;
            if (form != null) form.SuspendLayout();
            // 15.02.12 TQT It's important to reset Docking/Anchor style to default value before moving to another container.
            Anchor = AnchorStyles.Top | AnchorStyles.Left;
            bool fisrtDisplay = false;
            forceDispose = true;
            if (_form == null)
            {
                _form = new Form();
                _form.Width = this.Width;
                _form.Height = this.Height + 30;
                _form.MinimumSize = Size;
                _form.MaximizeBox = _form.MinimizeBox = false;
                _form.Text = Text;
                //_form.BorderStyle = BorderStyle.FixedSingle;
                _form.StartPosition = FormStartPosition.CenterScreen;
                fisrtDisplay = true;
                _form.FormClosing += new Wisej.Web.FormClosingEventHandler(form_FormClosing);                
            }
            _form.SuspendLayout();
            if (_panel != null)
            {
                _panel.SuspendLayout();
                _panel.Controls.Remove(this);
                _panel.Height = 0;
                _panel.ResumeLayout(false);
            }
            _form.Controls.Add(this);
            _form.Height = this.Height + 30;
            _form.Width = this.Width;
            _form.ResumeLayout(false);
            _form.Show();
            menuItemDialog.Visible = false;
            menuItemPanel.Visible = true;
            if (!fisrtDisplay)
            {
                if (_relativePanel != null) _relativePanel.Height += this.Height;
            }
            Anchor = AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Bottom | AnchorStyles.Right;
            if (form != null) form.ResumeLayout(false);
        }

        public void Collapse()
        {
            Form form = ParentForm;
            if (form != null) form.SuspendLayout();
            // 15.02.12 TQT It's important to reset Docking/Anchor style to default value before moving to another container.
            Anchor = AnchorStyles.Top | AnchorStyles.Left;            
            if (_panel != null)
            {
                _panel.Controls.Remove(this);
                _panel.Height = 0;
            }            
            menuItemDialog.Visible = false;
            menuItemPanel.Visible = true;            
            Anchor = AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Bottom | AnchorStyles.Right;
            if (form != null) form.ResumeLayout(false);
        }

        // 26.07.12 TQT added to support default behavior of dialog on Enter/Escape pressing
        protected virtual Button GetAcceptButton()
        {
            return null;
        }
        protected virtual Button GetCancelButton()
        {
            return null;
        }
        // end of modification 26.07.12
        //
        // 02.02.12 TQT added to support classical modal edit
        public void ShowModal()
        {
            //bool fisrtDisplay = false;
            forceDispose = true;
            if (_form == null)
            {
                _form = new Form();
                _form.Width = this.Width;
                _form.Height = this.Height + 30;
                _form.MaximizeBox = _form.MinimizeBox = false;
                _form.Text = Text;
                //_form.BorderStyle = BorderStyle.FixedSingle;
                //fisrtDisplay = true;
                _form.FormClosed += new Wisej.Web.FormClosedEventHandler(form_FormClosed);
                _form.StartPosition = FormStartPosition.CenterScreen;
                // 26.07.12 TQT added to support default behavior of dialog on Enter/Escape pressing
                if (GetAcceptButton() != null)
                    _form.AcceptButton = GetAcceptButton();
                if (GetCancelButton() != null)
                    _form.CancelButton = GetCancelButton();
                ///////////////////////////////////////////
            }
            _form.SuspendLayout();
            if (_panel != null)
            {
                _panel.Controls.Remove(this);
                _panel.Height = 1;
            }
            _form.Controls.Add(this);
            Anchor = AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Bottom | AnchorStyles.Right;
            _form.ResumeLayout();
            _form.ShowDialog();
            //menuItemDialog.Visible = false;
            //menuItemPanel.Visible = true;
            //if (!fisrtDisplay)
            //{
            //    if (_relativePanel != null) _relativePanel.Height += this.Height;
            //}
        }

        //29.1.12 Szabo - ak je okno v tvare Form, ukonci ho
        public void CloseForm()
        {
            if (this._form != null)
            {
                _form.Controls.Remove(this);
                this._form.Close();
                this.DisposeAll();
                _form = null;
            }
        }

        void form_FormClosing(object sender, FormClosingEventArgs e)
        {
          

            //if (CloseDetail != null) CloseDetail(null, null);
        }


        void form_FormClosed(object sender, FormClosedEventArgs e)
        {
            //if (CloseDetail != null) CloseDetail(null, null);
        }

        public DockableControl()
        {
            InitializeComponent();
            //Use extend button to show on dialog
            //this.Cursor = Cursors.Hand;
            DockAnchor = AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Bottom;
        }

        private void menuItemDialog_Click(object sender, EventArgs e)
        {
            ShowInDialog();
        }

        private void menuItemPanel_Click(object sender, EventArgs e)
        {
           
        }

        private void menuItemHide_Click(object sender, EventArgs e)
        {

        }

        protected virtual void DockableControl_DoubleClick(object sender, EventArgs e)
        {
            if (this.Parent is Panel)
            {
                ShowInDialog();
            }
            else
            {
            }
        }
        bool forceDispose = false;
        public void DisposeAll()
        {
            if (_form != null)
            {
                forceDispose = true;
                _panel = null;
                _form.Close();
                _form = null;
            }
        }
    }
}
