﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Wisej.Core;

namespace WisejWebApplication
{
	public class TestDataGridView : Wisej.Web.DataGridView
	{
		protected override void OnControlCreated(EventArgs e)
		{

            // attach javascript event to defer the selection change.
            AddClientEventListener("selectionChanged",
            @"
          alert('aaaa');
			var me = this, data = e.getData();
			clearTimeout(this._selectionChangedTimer);
			this._selectionChangedTimer = setTimeout(function() {
debugger;
alert('hhe');
				me.fireDataEvent('lazySelectionChanged', data);
			}, 250);

			");

            // attach javascript event to defer the selection change.
            AddClientEventListener("focusCellChanged",
            @"

            			var me = this, data = e.getData();
            			clearTimeout(this._focusCellChanged);
            			this._focusCellChangedTimer = setTimeout(function() {
            				me.fireDataEvent('lazyfocusCellChanged', data);
            			}, 250);

            			");

            base.OnControlCreated(e);
		}

		protected override void OnWebEvent(WisejEventArgs e)
		{
			switch (e.Type)
			{
				case "lazySelectionChanged":
					{
						var args = new WisejEventArgs(this, "selectionChanged", new DynamicObject());
						args.Parameters.Data = e.Parameters.Data;
						base.OnWebEvent(args);
					}
					break;

				case "lazyFocusCellChanged":
					{
						var args = new WisejEventArgs(this, "focusCellChanged", new DynamicObject());
						args.Parameters.Cell = e.Parameters.Cell;
						base.OnWebEvent(args);
					}
					break;

				default:
					base.OnWebEvent(e);
					break;
			}
		}

		protected override void OnWebRender(dynamic config)
		{
			base.OnWebRender((object)config);

			// detach the live event.
			config.wiredEvents.Remove("selectionChanged(Data)");
			config.wiredEvents.Remove("focusCellChanged(Cell)");

            // attach deferred event.
            config.wiredEvents.Add("lazySelectionChanged(Data)","lazyFocusCellChanged(Cell)");
		}
	}
}